/***************************************************************************
*	Brutal Chess Pre-Alpha Build
*	- gnuchessplayer.H
*
*	Authors: Maxwell Lazaroff, Michael Cook, and Joe Flint
*	Date Created : November 5th, 2005
*	Last Modified: November 5th, 2005
*
*	- description - Defines the GNUChess chessplayer subclass.
***************************************************************************/

#ifndef _GNUCHESSPLAYER_H
#define _GNUCHESSPLAYER_H

class 
GNUChessPlayer : public ChessPlayer
{
public:

	// Constructor for GNUChessPlayer
	GNUChessPlayer() : ChessPlayer("gnuchess") { init = false; }

	void runGNUChess();
	virtual bool requiresInput() { return false; }
	virtual ChessPlayer* dup() const { return new GNUChessPlayer(); }
	virtual BoardMove decide_move(const Board & board, bool & player);
	virtual void opponent_move( const BoardMove & move, bool white );

	int to[2];
	int from[2];
	bool init;
};

#endif // _GNUCHESSPLAYER_H

// End of file gnuchessplayer.h